{
Unit: DVplay
Autor: Fabiano Ferreira
Data: 23/03/2017
Objetivo: oferecer recursos para programas que necessitem
tocar audio
}

unit dvplay;

interface


function mOpen (nomearq,nomedisp : string): boolean;
function mclose (nomedisp : string): boolean;
function mplay (nomedisp : string): boolean;
procedure mpause(nomedisp: string);
procedure mvolup(nomedisp: string);
procedure mvoldown(nomedisp: string);
procedure mvolset(valvol: integer; nomedisp : string);
procedure mgo(nomedisp: string);
procedure mback (nomedisp: string);
procedure mgoto(posicaudio : integer; nomedisp : string);
function mnowtime(nomedisp : string): longint;
function mtotaltime(nomedisp : string) : longint;
procedure fadein(veloc,limite: integer;nomedisp: string);
procedure fadeout(veloc,limite : integer; nomedisp : string);
procedure preparavideo(nomedisp: string; numerojan : integer);

const
    xIniTela = 1;       {* Linha e Coluna para reproduo de vdeo *}
    yIniTela = 5;

var volume : integer;
tocandovideo : boolean;
pausado : boolean;
implementation
uses sysutils, mmsystem, dialogs, dvcrt;
var
retorno: array [0..1024] of char;
//Funo auxiliar para enviar os comandos mci
function enviacomandomci(cmd : string): boolean;
var
comando : array [0..1024] of char;
    erro: longint;
begin
enviacomandomci := false;

         strPCopy (comando, cmd);
         erro := mciSendString(comando, retorno, 80, 0);
if erro = 0 then enviacomandomci := true;
end;

Function GetParamComandoMCI (cmd : string): string;
var
    comando : array [0..512] of char;
    erro: longint;
    retorno: array [0..512] of char;

begin
    result := '';
    strPCopy (comando, cmd);
    erro := mciSendString(comando, retorno, 512, 0);
    if erro = 0 then
        result := StrPas(retorno);
end;

//carrega o  udio
function mOpen (nomearq,nomedisp : string): boolean;
var copen, apelido : string;

begin
mopen := false;
apelido := ' alias '+nomedisp;
copen := 'open "mpegvideo!'+nomearq+'"';
if enviacomandomci(copen+apelido) then
mopen := true;
end;

//libera o udio que foi aberto
function mclose (nomedisp : string): boolean;
var cclose : string;
begin
mclose := false;
cclose := 'close '+nomedisp;
if enviacomandomci(cclose) then mclose := true;
end;

//toca o udio que foi previamente aberto
function mplay (nomedisp : string): boolean;
var cplay : string;
begin
mplay := false;
cplay := 'play '+nomedisp;
if enviacomandomci(cplay) then
begin
mplay := true;
pausado := false;
end;
end;

//devolve o tempo total do audio em milisegundos
function mtotaltime(nomedisp : string) : longint;
var
cstatus : string;
begin
mtotaltime := 0;
cstatus := 'status '+nomedisp+' length';
if not enviacomandomci(cstatus) then exit;
mtotaltime := strtoint(retorno);
end;

//devolve tempo atual do audio em milisegundos
function mnowtime(nomedisp : string): longint;
var
cstatus : string;
begin
mnowtime := 0;
cstatus := 'status '+nomedisp+' position';
if not enviacomandomci(cstatus) then exit;
mnowtime := strtoint(retorno);
end;

//pausa o udio corrente
procedure mpause(nomedisp: string);
var cpause : string;
begin
cpause := 'pause '+nomedisp;
if not pausado then
begin
if enviacomandomci(cpause) then
 pausado := true;
end
else
mplay(nomedisp);
end;

//aumenta o volume do udio corrente
procedure mvolup(nomedisp: string);
var
volesquerdo, voldireito : string;
recuperavolume : integer;

begin
recuperavolume := volume;
volesquerdo := 'setaudio '+nomedisp+' left volume to ';
voldireito := 'setaudio '+nomedisp+' right volume to ';

volume := volume + 50;
if volume > 1000 then
begin
volume := recuperavolume;
exit;
end;

enviacomandomci(volesquerdo+inttostr(volume));
enviacomandomci(voldireito+inttostr(volume));
end;

//abaixa o volume do udio corrente
procedure mvoldown(nomedisp: string);
var
volesquerdo, voldireito : string;
recuperavolume : integer;

begin
recuperavolume := volume;
volesquerdo := 'setaudio '+nomedisp+' left volume to ';
voldireito := 'setaudio '+nomedisp+' right volume to ';

volume := volume - 50;
if volume < 0 then
begin
volume := recuperavolume;
exit;
end;

enviacomandomci(volesquerdo+inttostr(volume));
enviacomandomci(voldireito+inttostr(volume));
end;

//ajusta o volume do audio
procedure mvolset(valvol: integer; nomedisp : string);
var volesquerdo, voldireito: string;
begin
volesquerdo := 'setaudio '+nomedisp+' left volume to ';
voldireito := 'setaudio '+nomedisp+' right volume to ';
enviacomandomci (volesquerdo+inttostr(valvol));
enviacomandomci (voldireito+inttostr(valvol));
end;

//avana 5 segundos no udio corrente
procedure mgo(nomedisp: string);
var tamtotal, posatual, avanca : integer;
cseek : string;
begin
tamtotal := mtotaltime(nomedisp);
posatual := mnowtime(nomedisp);
cseek := 'play '+nomedisp+' from ';
avanca := posatual + 5000;
if avanca >= tamtotal then
avanca := avanca - 4000;
enviacomandomci (cseek+inttostr(avanca));
end;

//recua 5 segundos no audio corrente
procedure mback (nomedisp: string);
var  posatual, recua : integer;
cseek : string;
begin
posatual := mnowtime(nomedisp);
cseek := 'play '+nomedisp+' from ';
recua := posatual - 5000;
if recua < 1 then
recua := 1;
enviacomandomci (cseek+inttostr(recua));
end;

//pula para um ponto no udio
procedure mgoto(posicaudio : integer; nomedisp : string);
var cseek : string;
tamtotal : integer;
begin
cseek := 'play '+nomedisp+' from ';
tamtotal := mtotaltime(nomedisp);
if posicaudio > tamtotal then exit;
enviacomandomci (cseek+inttostr(posicaudio));
end;

//Aumenta o volume gradativamente (fade in)
procedure fadein(veloc,limite: integer; nomedisp: string);
begin
while ( volume < limite) do
begin
mvolup(nomedisp);
sleep(veloc);
end;
end;

//Diminui o volume gradativamente (fade out)
procedure fadeout(veloc,limite: integer; nomedisp: string);
begin
while ( volume > limite) do
begin
mvoldown(nomedisp);
sleep(veloc);
end;
end;

//prepara regio da tela para reproduo de vdeos
procedure preparavideo(nomedisp: string; numerojan : integer);
var
    s: string;
    p: integer;

    xTela:  integer;
    yTela:  integer;
    dxTela: integer;
    dyTela: integer;

    dxVideo: integer;
    dyVideo: integer;

label
    pronto;

begin
    { Local destinado a reproduo de vdeos }
    xTela  := (xIniTela-1)  * CharSize.X;
    yTela  := (yIniTela-1)  * CharSize.Y;
    dxTela := 80 * CharSize.X - xTela -1;
    dyTela := 25 * CharSize.Y - yTela -1;

    s := trim (GetParamComandoMCI ('where '+nomedisp+' source'));

    p := pos (' ', s);
    if p = 0 then goto pronto;
    delete (s, 1, p);
    s := trim (s);

    p := pos (' ', s);
    if p = 0 then goto pronto;
    delete (s, 1, p);
    s := trim (s);

    p := pos (' ', s);
    if p = 0 then goto pronto;
    dxVideo := StrToInt (trim (copy (s, 1, p))) * 100;
    dyVideo := StrToInt (trim (copy (s, p, length(s) - p+1))) * 100;

    if dxVideo > dxTela then
        begin
            dyVideo := trunc (dyVideo * (dxTela / dxVideo));
            dxVideo := dxTela;
        end;
    if dyVideo > dyTela then
        begin
            dxVideo := trunc (dxVideo * (dyTela / dyVideo));
            dyVideo := dyTela;
        end;

enviaComandoMci ('window '+nomedisp+' handle '+ intToStr(numerojan));

pronto:
    tocandoVideo := True;
    enviaComandoMci ('put midia destination at ' +
                intToStr(xTela + (dxTela - dxVideo) div 2) + ' ' +
                intToStr(yTela + (dyTela - dyVideo) div 2) + ' ' +
                intToStr(dxVideo) + ' ' +
                intToStr(dyVideo));
end;

//inicializa volume
begin
volume := 1000;

end.
